// FullAccess
resource "azurerm_role_definition" "virtual_network_fullaccess_definition" {
  name              = "virtual-network-fullaccess-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = [
      "Microsoft.Network/register/action",
      "Microsoft.Network/unregister/action",
      "Microsoft.Network/checkTrafficManagerNameAvailability/action",
      "Microsoft.Network/checkFrontDoorNameAvailability/action",
      "Microsoft.Network/bgpServiceCommunities/read",
      "Microsoft.Network/locations/virtualNetworkAvailableEndpointServices/read",
      "Microsoft.Network/locations/availableDelegations/read",
      "Microsoft.Network/locations/supportedVirtualMachineSizes/read",
      "Microsoft.Network/locations/checkAcceleratedNetworkingSupport/action",
      "Microsoft.Network/locations/checkPrivateLinkServiceVisibility/action",
      "Microsoft.Network/locations/bareMetalTenants/action",
      "Microsoft.Network/routeFilters/read",
      "Microsoft.Network/routeFilters/join/action",
      "Microsoft.Network/routeFilters/delete",
      "Microsoft.Network/routeFilters/write",
      "Microsoft.Network/routeFilters/routeFilterRules/read",
      "Microsoft.Network/routeFilters/routeFilterRules/write",
      "Microsoft.Network/routeFilters/routeFilterRules/delete",
      "Microsoft.Network/virtualNetworks/read",
      "Microsoft.Network/virtualNetworks/write",
      "Microsoft.Network/virtualNetworks/delete",
      "Microsoft.Network/virtualNetworks/peer/action",
      "Microsoft.Network/virtualNetworks/BastionHosts/action",
      "Microsoft.Network/virtualNetworks/virtualMachines/read",
      "Microsoft.Network/virtualNetworks/subnets/read",
      "Microsoft.Network/virtualNetworks/subnets/write",
      "Microsoft.Network/virtualNetworks/subnets/delete",
      "Microsoft.Network/virtualNetworks/subnets/join/action",
      "Microsoft.Network/virtualNetworks/subnets/joinViaServiceEndpoint/action",
      "Microsoft.Network/virtualNetworks/subnets/prepareNetworkPolicies/action",
      "Microsoft.Network/virtualNetworks/virtualNetworkPeerings/read",
      "Microsoft.Network/virtualNetworks/virtualNetworkPeerings/write",
      "Microsoft.Network/virtualNetworks/virtualNetworkPeerings/delete",
      "Microsoft.Network/virtualNetworks/checkIpAddressAvailability/read",
      "Microsoft.Network/virtualNetworks/usages/read",
      "Microsoft.Network/virtualNetworks/subnets/virtualMachines/read",
      "Microsoft.Network/publicIPAddresses/read",
      "Microsoft.Network/publicIPAddresses/write",
      "Microsoft.Network/publicIPAddresses/delete",
      "Microsoft.Network/publicIPAddresses/join/action",
      "Microsoft.Network/networkInterfaces/read",
      "Microsoft.Network/networkInterfaces/write",
      "Microsoft.Network/networkInterfaces/join/action",
      "Microsoft.Network/networkInterfaces/delete",
      "Microsoft.Network/networkInterfaces/effectiveRouteTable/action",
      "Microsoft.Network/networkInterfaces/effectiveNetworkSecurityGroups/action",
      "Microsoft.Network/networkInterfaces/ipconfigurations/read",
      "Microsoft.Network/networkInterfaces/ipconfigurations/join/action",
      "Microsoft.Network/networkInterfaces/loadBalancers/read",
      "Microsoft.Network/serviceEndpointPolicies/read",
      "Microsoft.Network/serviceEndpointPolicies/write",
      "Microsoft.Network/serviceEndpointPolicies/delete",
      "Microsoft.Network/serviceEndpointPolicies/join/action",
      "Microsoft.Network/serviceEndpointPolicies/joinSubnet/action",
      "Microsoft.Network/serviceEndpointPolicies/serviceEndpointPolicyDefinitions/read",
      "Microsoft.Network/serviceEndpointPolicies/serviceEndpointPolicyDefinitions/write",
      "Microsoft.Network/serviceEndpointPolicies/serviceEndpointPolicyDefinitions/delete",
      "Microsoft.Network/routeTables/read",
      "Microsoft.Network/routeTables/write",
      "Microsoft.Network/routeTables/delete",
      "Microsoft.Network/routeTables/join/action",
      "Microsoft.Network/routeTables/routes/read",
      "Microsoft.Network/routeTables/routes/write",
      "Microsoft.Network/routeTables/routes/delete",
      "Microsoft.Network/locations/checkDnsNameAvailability/read",
      "Microsoft.Network/locations/usages/read",
      "Microsoft.Network/operations/read",
      "Microsoft.Network/locations/operations/read",
      "Microsoft.Network/locations/operationResults/read",
      "Microsoft.Network/connections/read",
      "Microsoft.Network/connections/write",
      "Microsoft.Network/connections/delete",
      "Microsoft.Network/connections/sharedkey/action",
      "Microsoft.Network/connections/vpndeviceconfigurationscript/action",
      "Microsoft.Network/connections/revoke/action",
      "Microsoft.Network/connections/sharedKey/read",
      "Microsoft.Network/connections/sharedKey/write",
      "Microsoft.Network/localnetworkgateways/read",
      "Microsoft.Network/localnetworkgateways/write",
      "Microsoft.Network/localnetworkgateways/delete",
      "Microsoft.Network/virtualNetworkTaps/read",
      "Microsoft.Network/virtualNetworkTaps/join/action",
      "Microsoft.Network/virtualNetworkTaps/delete",
      "Microsoft.Network/virtualNetworkTaps/write",
      "Microsoft.Network/virtualHubs/delete",
      "Microsoft.Network/virtualHubs/read",
      "Microsoft.Network/virtualHubs/write",
      "Microsoft.Network/virtualHubs/hubVirtualNetworkConnections/read",
      "Microsoft.Network/virtualHubs/hubVirtualNetworkConnections/write",
      "Microsoft.Network/virtualHubs/hubVirtualNetworkConnections/delete",
      "Microsoft.Network/securegateways/read",
      "Microsoft.Network/securegateways/write",
      "Microsoft.Network/securegateways/delete",
      "Microsoft.Network/networkProfiles/read",
      "Microsoft.Network/networkProfiles/write",
      "Microsoft.Network/networkProfiles/delete",
      "Microsoft.Network/networkProfiles/setContainers/action",
      "Microsoft.Network/networkProfiles/removeContainers/action",
      "Microsoft.Network/networkProfiles/setNetworkInterfaces/action",
      "Microsoft.Network/networkIntentPolicies/read",
      "Microsoft.Network/networkIntentPolicies/write",
      "Microsoft.Network/networkIntentPolicies/delete",
      "Microsoft.Network/publicIPPrefixes/read",
      "Microsoft.Network/publicIPPrefixes/write",
      "Microsoft.Network/publicIPPrefixes/delete",
      "Microsoft.Network/publicIPPrefixes/join/action",
      "Microsoft.Network/networkInterfaces/tapConfigurations/read",
      "Microsoft.Network/networkInterfaces/tapConfigurations/write",
      "Microsoft.Network/networkInterfaces/tapConfigurations/delete",
      "Microsoft.Network/privateLinkServices/read",
      "Microsoft.Network/privateLinkServices/write",
      "Microsoft.Network/privateLinkServices/delete",
      "Microsoft.Network/virtualNetworks/bastionHosts/default/action",
      "Microsoft.Network/privateEndpoints/read",
      "Microsoft.Network/privateEndpoints/write",
      "Microsoft.Network/privateEndpoints/delete",
      "Microsoft.Network/privateLinkServices/privateEndpointConnections/read",
      "Microsoft.Network/privateLinkServices/privateEndpointConnections/write",
      "Microsoft.Network/privateLinkServices/privateEndpointConnections/delete",
      "Microsoft.Network/locations/serviceTags/read",
      "Microsoft.Network/locations/availablePrivateEndpointTypes/read",
      "Microsoft.Network/locations/autoApprovedPrivateLinkServices/read",
    ]

    not_actions = []
  }
}

// ReadOnly
resource "azurerm_role_definition" "virtual_network_readonly_definition" {
  name              = "virtual-network-readonly-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = [
      "Microsoft.Network/bgpServiceCommunities/read",
      "Microsoft.Network/locations/virtualNetworkAvailableEndpointServices/read",
      "Microsoft.Network/locations/availableDelegations/read",
      "Microsoft.Network/locations/supportedVirtualMachineSizes/read",
      "Microsoft.Network/routeFilters/read",
      "Microsoft.Network/routeFilters/routeFilterRules/read",
      "Microsoft.Network/virtualNetworks/read",
      "Microsoft.Network/virtualNetworks/virtualMachines/read",
      "Microsoft.Network/virtualNetworks/subnets/read",
      "Microsoft.Network/virtualNetworks/virtualNetworkPeerings/read",
      "Microsoft.Network/virtualNetworks/checkIpAddressAvailability/read",
      "Microsoft.Network/virtualNetworks/usages/read",
      "Microsoft.Network/virtualNetworks/subnets/virtualMachines/read",
      "Microsoft.Network/publicIPAddresses/read",
      "Microsoft.Network/networkInterfaces/read",
      "Microsoft.Network/networkInterfaces/ipconfigurations/read",
      "Microsoft.Network/networkInterfaces/loadBalancers/read",
      "Microsoft.Network/serviceEndpointPolicies/read",
      "Microsoft.Network/serviceEndpointPolicies/serviceEndpointPolicyDefinitions/read",
      "Microsoft.Network/routeTables/read",
      "Microsoft.Network/routeTables/routes/read",
      "Microsoft.Network/locations/checkDnsNameAvailability/read",
      "Microsoft.Network/locations/usages/read",
      "Microsoft.Network/operations/read",
      "Microsoft.Network/locations/operations/read",
      "Microsoft.Network/locations/operationResults/read",
      "Microsoft.Network/connections/read",
      "Microsoft.Network/connections/sharedKey/read",
      "Microsoft.Network/localnetworkgateways/read",
      "Microsoft.Network/virtualNetworkTaps/read",
      "Microsoft.Network/virtualHubs/read",
      "Microsoft.Network/virtualHubs/hubVirtualNetworkConnections/read",
      "Microsoft.Network/securegateways/read",
      "Microsoft.Network/networkProfiles/read",
      "Microsoft.Network/networkIntentPolicies/read",
      "Microsoft.Network/publicIPPrefixes/read",
      "Microsoft.Network/networkInterfaces/tapConfigurations/read",
      "Microsoft.Network/privateLinkServices/read",
      "Microsoft.Network/privateEndpoints/read",
      "Microsoft.Network/privateLinkServices/privateEndpointConnections/read",
      "Microsoft.Network/locations/serviceTags/read",
      "Microsoft.Network/locations/availablePrivateEndpointTypes/read",
      "Microsoft.Network/locations/autoApprovedPrivateLinkServices/read",
    ]

    not_actions = [
      "Microsoft.Network/register/action",
      "Microsoft.Network/unregister/action",
      "Microsoft.Network/checkTrafficManagerNameAvailability/action",
      "Microsoft.Network/checkFrontDoorNameAvailability/action",
      "Microsoft.Network/locations/checkAcceleratedNetworkingSupport/action",
      "Microsoft.Network/locations/checkPrivateLinkServiceVisibility/action",
      "Microsoft.Network/locations/bareMetalTenants/action",
      "Microsoft.Network/routeFilters/join/action",
      "Microsoft.Network/routeFilters/delete",
      "Microsoft.Network/routeFilters/write",
      "Microsoft.Network/routeFilters/routeFilterRules/write",
      "Microsoft.Network/routeFilters/routeFilterRules/delete",
      "Microsoft.Network/virtualNetworks/write",
      "Microsoft.Network/virtualNetworks/delete",
      "Microsoft.Network/virtualNetworks/peer/action",
      "Microsoft.Network/virtualNetworks/BastionHosts/action",
      "Microsoft.Network/virtualNetworks/subnets/write",
      "Microsoft.Network/virtualNetworks/subnets/delete",
      "Microsoft.Network/virtualNetworks/subnets/join/action",
      "Microsoft.Network/virtualNetworks/subnets/joinViaServiceEndpoint/action",
      "Microsoft.Network/virtualNetworks/subnets/prepareNetworkPolicies/action",
      "Microsoft.Network/virtualNetworks/virtualNetworkPeerings/write",
      "Microsoft.Network/virtualNetworks/virtualNetworkPeerings/delete",
      "Microsoft.Network/publicIPAddresses/write",
      "Microsoft.Network/publicIPAddresses/delete",
      "Microsoft.Network/publicIPAddresses/join/action",
      "Microsoft.Network/networkInterfaces/write",
      "Microsoft.Network/networkInterfaces/join/action",
      "Microsoft.Network/networkInterfaces/delete",
      "Microsoft.Network/networkInterfaces/effectiveRouteTable/action",
      "Microsoft.Network/networkInterfaces/effectiveNetworkSecurityGroups/action",
      "Microsoft.Network/networkInterfaces/ipconfigurations/join/action",
      "Microsoft.Network/serviceEndpointPolicies/write",
      "Microsoft.Network/serviceEndpointPolicies/delete",
      "Microsoft.Network/serviceEndpointPolicies/join/action",
      "Microsoft.Network/serviceEndpointPolicies/joinSubnet/action",
      "Microsoft.Network/serviceEndpointPolicies/serviceEndpointPolicyDefinitions/write",
      "Microsoft.Network/serviceEndpointPolicies/serviceEndpointPolicyDefinitions/delete",
      "Microsoft.Network/routeTables/write",
      "Microsoft.Network/routeTables/delete",
      "Microsoft.Network/routeTables/join/action",
      "Microsoft.Network/routeTables/routes/write",
      "Microsoft.Network/routeTables/routes/delete",
      "Microsoft.Network/connections/write",
      "Microsoft.Network/connections/delete",
      "Microsoft.Network/connections/sharedkey/action",
      "Microsoft.Network/connections/vpndeviceconfigurationscript/action",
      "Microsoft.Network/connections/revoke/action",
      "Microsoft.Network/connections/sharedKey/write",
      "Microsoft.Network/localnetworkgateways/write",
      "Microsoft.Network/localnetworkgateways/delete",
      "Microsoft.Network/virtualNetworkTaps/join/action",
      "Microsoft.Network/virtualNetworkTaps/delete",
      "Microsoft.Network/virtualNetworkTaps/write",
      "Microsoft.Network/virtualHubs/delete",
      "Microsoft.Network/virtualHubs/write",
      "Microsoft.Network/virtualHubs/hubVirtualNetworkConnections/write",
      "Microsoft.Network/virtualHubs/hubVirtualNetworkConnections/delete",
      "Microsoft.Network/securegateways/write",
      "Microsoft.Network/securegateways/delete",
      "Microsoft.Network/networkProfiles/write",
      "Microsoft.Network/networkProfiles/delete",
      "Microsoft.Network/networkProfiles/setContainers/action",
      "Microsoft.Network/networkProfiles/removeContainers/action",
      "Microsoft.Network/networkProfiles/setNetworkInterfaces/action",
      "Microsoft.Network/networkIntentPolicies/write",
      "Microsoft.Network/networkIntentPolicies/delete",
      "Microsoft.Network/publicIPPrefixes/write",
      "Microsoft.Network/publicIPPrefixes/delete",
      "Microsoft.Network/publicIPPrefixes/join/action",
      "Microsoft.Network/networkInterfaces/tapConfigurations/write",
      "Microsoft.Network/networkInterfaces/tapConfigurations/delete",
      "Microsoft.Network/privateLinkServices/write",
      "Microsoft.Network/privateLinkServices/delete",
      "Microsoft.Network/virtualNetworks/bastionHosts/default/action",
      "Microsoft.Network/privateEndpoints/write",
      "Microsoft.Network/privateEndpoints/delete",
      "Microsoft.Network/privateLinkServices/privateEndpointConnections/write",
      "Microsoft.Network/privateLinkServices/privateEndpointConnections/delete",
    ]
  }
}

// NoAccess
resource "azurerm_role_definition" "virtual_network_noaccess_definition" {
  name              = "virtual-network-noaccess-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = []

    not_actions = [
      "Microsoft.Network/register/action",
      "Microsoft.Network/unregister/action",
      "Microsoft.Network/checkTrafficManagerNameAvailability/action",
      "Microsoft.Network/checkFrontDoorNameAvailability/action",
      "Microsoft.Network/bgpServiceCommunities/read",
      "Microsoft.Network/locations/virtualNetworkAvailableEndpointServices/read",
      "Microsoft.Network/locations/availableDelegations/read",
      "Microsoft.Network/locations/supportedVirtualMachineSizes/read",
      "Microsoft.Network/locations/checkAcceleratedNetworkingSupport/action",
      "Microsoft.Network/locations/checkPrivateLinkServiceVisibility/action",
      "Microsoft.Network/locations/bareMetalTenants/action",
      "Microsoft.Network/routeFilters/read",
      "Microsoft.Network/routeFilters/join/action",
      "Microsoft.Network/routeFilters/delete",
      "Microsoft.Network/routeFilters/write",
      "Microsoft.Network/routeFilters/routeFilterRules/read",
      "Microsoft.Network/routeFilters/routeFilterRules/write",
      "Microsoft.Network/routeFilters/routeFilterRules/delete",
      "Microsoft.Network/virtualNetworks/read",
      "Microsoft.Network/virtualNetworks/write",
      "Microsoft.Network/virtualNetworks/delete",
      "Microsoft.Network/virtualNetworks/peer/action",
      "Microsoft.Network/virtualNetworks/BastionHosts/action",
      "Microsoft.Network/virtualNetworks/virtualMachines/read",
      "Microsoft.Network/virtualNetworks/subnets/read",
      "Microsoft.Network/virtualNetworks/subnets/write",
      "Microsoft.Network/virtualNetworks/subnets/delete",
      "Microsoft.Network/virtualNetworks/subnets/join/action",
      "Microsoft.Network/virtualNetworks/subnets/joinViaServiceEndpoint/action",
      "Microsoft.Network/virtualNetworks/subnets/prepareNetworkPolicies/action",
      "Microsoft.Network/virtualNetworks/virtualNetworkPeerings/read",
      "Microsoft.Network/virtualNetworks/virtualNetworkPeerings/write",
      "Microsoft.Network/virtualNetworks/virtualNetworkPeerings/delete",
      "Microsoft.Network/virtualNetworks/checkIpAddressAvailability/read",
      "Microsoft.Network/virtualNetworks/usages/read",
      "Microsoft.Network/virtualNetworks/subnets/virtualMachines/read",
      "Microsoft.Network/publicIPAddresses/read",
      "Microsoft.Network/publicIPAddresses/write",
      "Microsoft.Network/publicIPAddresses/delete",
      "Microsoft.Network/publicIPAddresses/join/action",
      "Microsoft.Network/networkInterfaces/read",
      "Microsoft.Network/networkInterfaces/write",
      "Microsoft.Network/networkInterfaces/join/action",
      "Microsoft.Network/networkInterfaces/delete",
      "Microsoft.Network/networkInterfaces/effectiveRouteTable/action",
      "Microsoft.Network/networkInterfaces/effectiveNetworkSecurityGroups/action",
      "Microsoft.Network/networkInterfaces/ipconfigurations/read",
      "Microsoft.Network/networkInterfaces/ipconfigurations/join/action",
      "Microsoft.Network/networkInterfaces/loadBalancers/read",
      "Microsoft.Network/serviceEndpointPolicies/read",
      "Microsoft.Network/serviceEndpointPolicies/write",
      "Microsoft.Network/serviceEndpointPolicies/delete",
      "Microsoft.Network/serviceEndpointPolicies/join/action",
      "Microsoft.Network/serviceEndpointPolicies/joinSubnet/action",
      "Microsoft.Network/serviceEndpointPolicies/serviceEndpointPolicyDefinitions/read",
      "Microsoft.Network/serviceEndpointPolicies/serviceEndpointPolicyDefinitions/write",
      "Microsoft.Network/serviceEndpointPolicies/serviceEndpointPolicyDefinitions/delete",
      "Microsoft.Network/routeTables/read",
      "Microsoft.Network/routeTables/write",
      "Microsoft.Network/routeTables/delete",
      "Microsoft.Network/routeTables/join/action",
      "Microsoft.Network/routeTables/routes/read",
      "Microsoft.Network/routeTables/routes/write",
      "Microsoft.Network/routeTables/routes/delete",
      "Microsoft.Network/locations/checkDnsNameAvailability/read",
      "Microsoft.Network/locations/usages/read",
      "Microsoft.Network/operations/read",
      "Microsoft.Network/locations/operations/read",
      "Microsoft.Network/locations/operationResults/read",
      "Microsoft.Network/connections/read",
      "Microsoft.Network/connections/write",
      "Microsoft.Network/connections/delete",
      "Microsoft.Network/connections/sharedkey/action",
      "Microsoft.Network/connections/vpndeviceconfigurationscript/action",
      "Microsoft.Network/connections/revoke/action",
      "Microsoft.Network/connections/sharedKey/read",
      "Microsoft.Network/connections/sharedKey/write",
      "Microsoft.Network/localnetworkgateways/read",
      "Microsoft.Network/localnetworkgateways/write",
      "Microsoft.Network/localnetworkgateways/delete",
      "Microsoft.Network/virtualNetworkTaps/read",
      "Microsoft.Network/virtualNetworkTaps/join/action",
      "Microsoft.Network/virtualNetworkTaps/delete",
      "Microsoft.Network/virtualNetworkTaps/write",
      "Microsoft.Network/virtualHubs/delete",
      "Microsoft.Network/virtualHubs/read",
      "Microsoft.Network/virtualHubs/write",
      "Microsoft.Network/virtualHubs/hubVirtualNetworkConnections/read",
      "Microsoft.Network/virtualHubs/hubVirtualNetworkConnections/write",
      "Microsoft.Network/virtualHubs/hubVirtualNetworkConnections/delete",
      "Microsoft.Network/securegateways/read",
      "Microsoft.Network/securegateways/write",
      "Microsoft.Network/securegateways/delete",
      "Microsoft.Network/networkProfiles/read",
      "Microsoft.Network/networkProfiles/write",
      "Microsoft.Network/networkProfiles/delete",
      "Microsoft.Network/networkProfiles/setContainers/action",
      "Microsoft.Network/networkProfiles/removeContainers/action",
      "Microsoft.Network/networkProfiles/setNetworkInterfaces/action",
      "Microsoft.Network/networkIntentPolicies/read",
      "Microsoft.Network/networkIntentPolicies/write",
      "Microsoft.Network/networkIntentPolicies/delete",
      "Microsoft.Network/publicIPPrefixes/read",
      "Microsoft.Network/publicIPPrefixes/write",
      "Microsoft.Network/publicIPPrefixes/delete",
      "Microsoft.Network/publicIPPrefixes/join/action",
      "Microsoft.Network/networkInterfaces/tapConfigurations/read",
      "Microsoft.Network/networkInterfaces/tapConfigurations/write",
      "Microsoft.Network/networkInterfaces/tapConfigurations/delete",
      "Microsoft.Network/privateLinkServices/read",
      "Microsoft.Network/privateLinkServices/write",
      "Microsoft.Network/privateLinkServices/delete",
      "Microsoft.Network/virtualNetworks/bastionHosts/default/action",
      "Microsoft.Network/privateEndpoints/read",
      "Microsoft.Network/privateEndpoints/write",
      "Microsoft.Network/privateEndpoints/delete",
      "Microsoft.Network/privateLinkServices/privateEndpointConnections/read",
      "Microsoft.Network/privateLinkServices/privateEndpointConnections/write",
      "Microsoft.Network/privateLinkServices/privateEndpointConnections/delete",
      "Microsoft.Network/locations/serviceTags/read",
      "Microsoft.Network/locations/availablePrivateEndpointTypes/read",
      "Microsoft.Network/locations/autoApprovedPrivateLinkServices/read",
    ]
  }
}
